#include "histogram.h"
#include <vector>

//    
void find_minmax(const std::vector<double>& numbers, double& Min, double& Max){
    if (numbers.size() == 0){
        return;
    }
    Min = numbers[0];
    Max = numbers[0];
    for (int i = 1; i < numbers.size(); i++) {
		if (numbers[i] > Max)
			Max = numbers[i];
		if (numbers[i] < Min)
			Min = numbers[i];
	}
	return;

}

//  
std::vector<size_t> make_histogram(const std::vector<double>& Numbers, size_t bin_count){
    //   
    double Max, Min;
    find_minmax(Numbers, Min, Max);
	double bin_size = (Max-Min) / bin_count;
	// 
	std::vector<size_t> bins(bin_count);
	for (size_t i = 0; i < bin_count; i++) //  
		bins[i] = 0;
	for (size_t i = 0; i < bin_count; i++) {
		double lo = Min + i * bin_size;
		double hi = Min + (i + 1) * bin_size;
		for (size_t j = 0; j < Numbers.size(); j++) {
			if (lo <= Numbers[j] && Numbers[j] <= hi)
				bins[i]++;
		}
	}
	return bins;
}
