#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <cmath>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>

using namespace std;

//  Input   
struct Input
{
    vector<double> Numbers;
    size_t bin_count{};
};

// 
Input input_data(istream& in, bool prompt)
{
    size_t number_count;
    Input stct;
    //   
    if (prompt)
    {
        cerr << "Enter number count ";
    }
    in >> number_count;
    // 
    vector<double> Numbers(number_count);
    stct.Numbers.resize(number_count);
    if (prompt)
    {
        cerr << "Enter array:\n";
    }
    in >> stct.Numbers[0];
    for (int i = 1; i < number_count; i++)
    {
        in >> stct.Numbers[i];
    }
    //  
    if (prompt)
    {
        cerr << "Enter bin count\n";
    }
    in >> stct.bin_count;
    // 
    return stct;
}

Input
download(const string& address)
{
    stringstream buffer;

    CURL *curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        res = curl_easy_perform(curl);
        if (res != CURLE_OK)
        {
            cerr << curl_easy_strerror(res);
            exit(1);
        }
        curl_easy_cleanup(curl);
    }
    return input_data(buffer, false);
}

int
main(int argc, char* argv[]) {
    Input input;
    if (argc > 1) {
        input = download(argv[1]);
    } else {
        input = input_data(cin, true);
    }

    const auto bins = make_histogram(input.Numbers, input.bin_count);
    show_histogram_svg(bins);
}
